## trilinos 12.14.1

=== CMakeLists.txt ===
# @HEADER
# ************************************************************************
#
#            Trilinos: An Object-Oriented Solver Framework
#                 Copyright (2001) Sandia Corporation
#
#
# Copyright (2001) Sandia Corporation. Under the terms of Contract
# DE-AC04-94AL85000, there is a non-exclusive license for use of this
# work by or on behalf of the U.S. Government.  Export of this program
# may require a license from the United States Government.
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# NOTICE:  The United States Government is granted for itself and others
# acting on its behalf a paid-up, nonexclusive, irrevocable worldwide
# license in this data to reproduce, prepare derivative works, and
# perform publicly and display publicly.  Beginning five (5) years from
# July 25, 2001, the United States Government is granted for itself and
# others acting on its behalf a paid-up, nonexclusive, irrevocable
# worldwide license in this data to reproduce, prepare derivative works,
# distribute copies to the public, perform publicly and display
# publicly, and to permit others to do so.
#
# NEITHER THE UNITED STATES GOVERNMENT, NOR THE UNITED STATES DEPARTMENT
# OF ENERGY, NOR SANDIA CORPORATION, NOR ANY OF THEIR EMPLOYEES, MAKES
# ANY WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR
# RESPONSIBILITY FOR THE ACCURACY, COMPLETENESS, OR USEFULNESS OF ANY
# INFORMATION, APPARATUS, PRODUCT, OR PROCESS DISCLOSED, OR REPRESENTS
# THAT ITS USE WOULD NOT INFRINGE PRIVATELY OWNED RIGHTS.
#
# ************************************************************************
# @HEADER

#
# A) Define your project name and set up major project options
#

# To be safe, define your minimum CMake version.  This may be newer than the
# min required by TriBITS.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11 FATAL_ERROR)

# Must set the project name as a variable at very beginning before including anything else
# We set the project name in a separate file so CTest scripts can use it.
INCLUDE(${CMAKE_SOURCE_DIR}/ProjectName.cmake)

# CMake requires that you declare the CMake project in the top-level file and
# not in an include file :-(
PROJECT(${PROJECT_NAME} NONE)

# Set default C++ standard to C++11
SET(Trilinos_ENABLE_CXX11_DEFAULT ON)

#
# B) Pull in the TriBITS system and execute
#

INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/tribits/TriBITS.cmake)


# Make Trilinos create <Package>Config.cmake files by default
SET(${PROJECT_NAME}_ENABLE_INSTALL_CMAKE_CONFIG_FILES_DEFAULT ON)
# Make Trilinos set up CPack support by default
SET(${PROJECT_NAME}_ENABLE_CPACK_PACKAGING_DEFAULT ON)
# Don't allow disabled subpackages to be excluded from tarball
SET(${PROJECT_NAME}_EXCLUDE_DISABLED_SUBPACKAGES_FROM_DISTRIBUTION_DEFAULT FALSE)

# Do all of the processing for this Tribits project
TRIBITS_PROJECT()

# Install TriBITS so that other projects can use it.
ADVANCED_SET(${PROJECT_NAME}_INSTALL_TriBITS ON CACHE BOOL
  "If ture, install TriBITS into <lib-install-dir>/cmake/tribits/")
IF (${PROJECT_NAME}_INSTALL_TriBITS)
  ASSERT_DEFINED(Trilinos_SOURCE_DIR)
  ASSERT_DEFINED(${PROJECT_NAME}_INSTALL_LIB_DIR)
  INSTALL(
    DIRECTORY "${Trilinos_SOURCE_DIR}/cmake/tribits"
    DESTINATION "${${PROJECT_NAME}_INSTALL_LIB_DIR}/cmake"
    )
ENDIF()

IF(${PROJECT_NAME}_ENABLE_YouCompleteMe)
  INCLUDE(CodeCompletion)
ENDIF()

=== commonTools/framework/CMakeLists.txt ===
TRIBITS_PACKAGE(TrilinosFrameworkTests)


TRIBITS_ADD_ADVANCED_TEST( ProjectCiFileChangeLogic_UnitTests
  OVERALL_WORKING_DIRECTORY TEST_NAME
  OVERALL_NUM_MPI_PROCS 1
  TEST_0 CMND ${PYTHON_EXECUTABLE} 
    ARGS ${CMAKE_CURRENT_SOURCE_DIR}/ProjectCiFileChangeLogic_UnitTests.py -v
    PASS_REGULAR_EXPRESSION "OK"
  )


FUNCTION(create_get_changed_trilinos_packages_test  TEST_POSTFIX
  FILES_CHANGED
  CHANGED_PACKAGES_FULL_LIST
  CHANGED_PACKAGES_PT_LIST
  EXPECTED_ENABLES_REGEX
  )

  SET(TEST_NAME "get_changed_trilinos_packages_test_${TEST_POSTFIX}")
  SET(FULL_TEST_NAME "${PACKAGE_NAME}_${TEST_NAME}")
  SET(ABS_TEST_DIR "${CMAKE_CURRENT_BINARY_DIR}/${FULL_TEST_NAME}")

  # We can't use real git in these automated tests so we use the handy
  # mockprogram.py script instead of git.
  SET(GIT_MOCKPROGRAM_TXT_FILE
    "${CMAKE_CURRENT_BINARY_DIR}/${FULL_TEST_NAME}_git_mockprogram.txt")

  # We need to write the expected input and the output for 
  FILE(WRITE "${GIT_MOCKPROGRAM_TXT_FILE}"
"MOCK_PROGRAM_INPUT: diff --name-only sha1-from..sha1-to
MOCK_PROGRAM_RETURN: 0
MOCK_PROGRAM_OUTPUT: ${FILES_CHANGED}
"
  )

  TRIBITS_ADD_ADVANCED_TEST( get_changed_trilinos_packages_test_${TEST_POSTFIX}
    OVERALL_WORKING_DIRECTORY TEST_NAME
    OVERALL_NUM_MPI_PROCS 1
    ENVIRONMENT # We can't use real git so we use mockprogram.py instead!
      GCTP_GIT_OVERRIDE=${${PROJECT_NAME}_TRIBITS_DIR}/python_utils/mockprogram.py
      MOCKPROGRAM_INOUT_FILE_OVERRIDE=${ABS_TEST_DIR}/mockprogram_inout.txt

    TEST_0
      MESSAGE "Copy the mockprogram.py inout file each time since it gets modifed!"
      CMND "${CMAKE_COMMAND}"
        ARGS -E copy "${GIT_MOCKPROGRAM_TXT_FILE}" mockprogram_inout.txt 

    TEST_1
      MESSAGE "Run get-changed-trilinos-packages.sh with mock git"
      CMND "${CMAKE_CURRENT_SOURCE_DIR}/get-changed-trilinos-packages.sh"
        ARGS sha1-from sha1-to packagesToEnable.cmake
      PASS_REGULAR_EXPRESSION_ALL
        "CHANGED_PACKAGES_FULL_LIST='${CHANGED_PACKAGES_FULL_LIST}'"
	"CHANGED_PACKAGES_PT_LIST='${CHANGED_PACKAGES_PT_LIST}'"

    TEST_2 CMND ${CMAKE_COMMAND}
      ARGS -P packagesToEnable.cmake
      PASS_REGULAR_EXPRESSION_ALL "${EXPECTED_ENABLES_REGEX}"

    )

ENDFUNCTION()


create_get_changed_trilinos_packages_test(ProjectsList_TeuchosCore
  "ProjectsList.cmake\npackages/teuchos/core/CMakeLists.txt"
  "ALL_PACKAGES,TeuchosCore"
  "ALL_PACKAGES,TeuchosCore"
  "Setting Trilinos_ENABLE_ALL_PACKAGES = ON;Setting Trilinos_ENABLE_TeuchosCore = ON"
  )
  # The above test ensures that it can detect global build files as well as
  # package files.


create_get_changed_trilinos_packages_test(cmake_std_atdm_TeuchosCore_PyTrilinos
  "cmake/std/atdm/anything\npackages/teuchos/core/CMakeLists.txt\npackages/PyTrilinos/anything"
  "TeuchosCore,PyTrilinos"
  "TeuchosCore"
  "Setting Trilinos_ENABLE_TeuchosCore = ON"
  )
  # The above test ensures that cmake/std/atdm/ changes don't trigger global
  # builds and it makes sure that ST packages (PyTrilinos) don't get enabled.


create_get_changed_trilinos_packages_test(cmake_std_atdm
  "cmake/std/atdm/anything\ncmake/std/atdm/shiller/tweaks/INTEL-RELEASE-OPENMP-HSW.cmake"
  ""
  ""
  "-- NOTE: No packages are being enabled!"
  )
  # The above test ensures that changes that don't anything are handled
  # smoothly


TRIBITS_PACKAGE_POSTPROCESS()

=== commonTools/gtest/CMakeLists.txt ===
#
# A) Define the package
#

TRIBITS_PACKAGE(Gtest)

#
# B) Set up package-specific options
#

# 
# Disable Gtest's use of pthread.
#
ADD_DEFINITIONS(-DGTEST_HAS_PTHREAD=0)

#
# C) Add the libraries, tests, and examples
#

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

APPEND_SET(HEADERS 
  ${CMAKE_CURRENT_SOURCE_DIR}/gtest/gtest.h
  )

APPEND_SET(SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/gtest/gtest-all.cc
  )

TRIBITS_ADD_LIBRARY(
  gtest
  NOINSTALLHEADERS ${HEADERS}
  SOURCES ${SOURCES}
  )

#install gtest header into the correct subdir.
INSTALL(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/${Trilinos_INSTALL_INCLUDE_DIR}/gtest/)

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/PyTrilinos/CMakeLists.txt ===
# -*- cmake -*-

# @HEADER
# ***********************************************************************
#
#          PyTrilinos: Python Interfaces to Trilinos Packages
#                 Copyright (2014) Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia
# Corporation, the U.S. Government retains certain rights in this
# software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Questions? Contact William F. Spotz (wfspotz@sandia.gov)
#
# ***********************************************************************
# @HEADER

# Include the package macros

# Set the package name
TRIBITS_PACKAGE(PyTrilinos DISABLE_STRONG_WARNINGS)

IF(NOT BUILD_SHARED_LIBS)
  MESSAGE(FATAL_ERROR "PyTrilinos can only be built with shared libraries. Building of shared libraries is currently set to OFF. To enable shared libraries please set the cache variable \"BUILD_SHARED_LIBS\" to ON")
ENDIF()

# Set the package version number
SET(PyTrilinos_VERSION 12.14)

# Define the list of PyTrilinos packages and modules.  Packages are
# the top-level names only, such as Epetra, AztecOO and NOX.  The list
# of modules is similar to the packages, except it contains the names
# of python modules that correspond to nested namespaces, such as
# NOX.__init__ or NOX.Epetra.Interface.
SET(PyTrilinos_PACKAGES "")
SET(PyTrilinos_MODULES  "")

APPEND_SET(PyTrilinos_PACKAGES Teuchos    )
APPEND_SET(PyTrilinos_MODULES  Teuchos    )

IF(PyTrilinos_ENABLE_Epetra)
  APPEND_SET(PyTrilinos_PACKAGES Epetra)
  APPEND_SET(PyTrilinos_MODULES  Epetra)
ENDIF(PyTrilinos_ENABLE_Epetra)

IF(PyTrilinos_ENABLE_Triutils)
  APPEND_SET(PyTrilinos_PACKAGES TriUtils)
  APPEND_SET(PyTrilinos_MODULES  TriUtils)
ENDIF(PyTrilinos_ENABLE_Triutils)

IF(PyTrilinos_ENABLE_Tpetra)
  APPEND_SET(PyTrilinos_PACKAGES Tpetra)
  APPEND_SET(PyTrilinos_MODULES  Tpetra)
ENDIF(PyTrilinos_ENABLE_Tpetra)

IF(PyTrilinos_ENABLE_Domi)
  APPEND_SET(PyTrilinos_PACKAGES Domi)
  APPEND_SET(PyTrilinos_MODULES  Domi)
ENDIF(PyTrilinos_ENABLE_Domi)

IF(PyTrilinos_ENABLE_EpetraExt)
  APPEND_SET(PyTrilinos_PACKAGES EpetraExt)
  APPEND_SET(PyTrilinos_MODULES  EpetraExt)
ENDIF(PyTrilinos_ENABLE_EpetraExt)

IF(PyTrilinos_ENABLE_Isorropia)
  APPEND_SET(PyTrilinos_PACKAGES Isorropia         )
  APPEND_SET(PyTrilinos_MODULES  Isorropia.__init__)
  IF(PyTrilinos_ENABLE_Epetra)
    Append_SET(PyTrilinos_MODULES Isorropia.Epetra)
  ENDIF(PyTrilinos_ENABLE_Epetra)
ENDIF(PyTrilinos_ENABLE_Isorropia)

IF(PyTrilinos_ENABLE_Pliris)
  APPEND_SET(PyTrilinos_PACKAGES Pliris)
  APPEND_SET(PyTrilinos_MODULES  Pliris)
ENDIF(PyTrilinos_ENABLE_Pliris)

IF(PyTrilinos_ENABLE_AztecOO)
  APPEND_SET(PyTrilinos_PACKAGES AztecOO)
  APPEND_SET(PyTrilinos_MODULES  AztecOO)
ENDIF(PyTrilinos_ENABLE_AztecOO)

IF(PyTrilinos_ENABLE_Galeri)
  APPEND_SET(PyTrilinos_PACKAGES Galeri)
  APPEND_SET(PyTrilinos_MODULES  Galeri)
ENDIF(PyTrilinos_ENABLE_Galeri)

IF(PyTrilinos_ENABLE_Amesos)
  APPEND_SET(PyTrilinos_PACKAGES Amesos)
  APPEND_SET(PyTrilinos_MODULES  Amesos)
ENDIF(PyTrilinos_ENABLE_Amesos)

IF(PyTrilinos_ENABLE_Ifpack)
  APPEND_SET(PyTrilinos_PACKAGES IFPACK)
  APPEND_SET(PyTrilinos_MODULES  IFPACK)
ENDIF(PyTrilinos_ENABLE_Ifpack)

IF(PyTrilinos_ENABLE_Komplex)
  APPEND_SET(PyTrilinos_PACKAGES Komplex)
  APPEND_SET(PyTrilinos_MODULES  Komplex)
ENDIF(PyTrilinos_ENABLE_Komplex)

IF(PyTrilinos_ENABLE_Anasazi)
  APPEND_SET(PyTrilinos_PACKAGES Anasazi)
  APPEND_SET(PyTrilinos_MODULES  Anasazi)
ENDIF(PyTrilinos_ENABLE_Anasazi)

IF(PyTrilinos_ENABLE_ML)
  APPEND_SET(PyTrilinos_PACKAGES ML)
  APPEND_SET(PyTrilinos_MODULES  ML)
ENDIF(PyTrilinos_ENABLE_ML)

IF(PyTrilinos_ENABLE_NOX)
  APPEND_SET(PyTrilinos_PACKAGES NOX)
  APPEND_SET(PyTrilinos_MODULES  NOX.__init__  )
  APPEND_SET(PyTrilinos_MODULES  NOX.Abstract  )
  APPEND_SET(PyTrilinos_MODULES  NOX.StatusTest)
  APPEND_SET(PyTrilinos_MODULES  NOX.Solver    )
  IF(NOX_ENABLE_Epetra)
    APPEND_SET(PyTrilinos_MODULES NOX.Epetra.__init__ )
    APPEND_SET(PyTrilinos_MODULES NOX.Epetra.Interface)
  ENDIF(NOX_ENABLE_Epetra)
  IF(NOX_ENABLE_PETSC)
    APPEND_SET(PyTrilinos_MODULES NOX.PETSc.__init__ )
    APPEND_SET(PyTrilinos_MODULES NOX.PETSc.Interface)
  ENDIF(NOX_ENABLE_PETSC)
ENDIF(PyTrilinos_ENABLE_NOX)

IF(NOX_ENABLE_LOCA)
  APPEND_SET(PyTrilinos_PACKAGES LOCA                                )
  APPEND_SET(PyTrilinos_MODULES  LOCA.__init__                       )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Abstract                       )
  APPEND_SET(PyTrilinos_MODULES  LOCA.AnasaziOperator                )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Bifurcation                    )
  APPEND_SET(PyTrilinos_MODULES  LOCA.BorderedSolver                 )
  APPEND_SET(PyTrilinos_MODULES  LOCA.BorderedSystem                 )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Eigensolver                    )
  APPEND_SET(PyTrilinos_MODULES  LOCA.EigenvalueSort                 )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Extended                       )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Homotopy                       )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Hopf.__init__                  )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Hopf.MinimallyAugmented        )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Hopf.MooreSpence               )
  APPEND_SET(PyTrilinos_MODULES  LOCA.MultiContinuation              )
  APPEND_SET(PyTrilinos_MODULES  LOCA.MultiPredictor                 )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Parameter                      )
  APPEND_SET(PyTrilinos_MODULES  LOCA.PhaseTransition                )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Pitchfork.__init__             )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Pitchfork.MinimallyAugmented   )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Pitchfork.MooreSpence          )
  APPEND_SET(PyTrilinos_MODULES  LOCA.SaveEigenData                  )
  APPEND_SET(PyTrilinos_MODULES  LOCA.StatusTest                     )
  APPEND_SET(PyTrilinos_MODULES  LOCA.StepSize                       )
  APPEND_SET(PyTrilinos_MODULES  LOCA.TimeDependent                  )
  APPEND_SET(PyTrilinos_MODULES  LOCA.TurningPoint.__init__          )
  APPEND_SET(PyTrilinos_MODULES  LOCA.TurningPoint.MinimallyAugmented)
  APPEND_SET(PyTrilinos_MODULES  LOCA.TurningPoint.MooreSpence       )
  IF(NOX_ENABLE_Epetra)
    APPEND_SET(PyTrilinos_MODULES  LOCA.Epetra.__init__ )
    APPEND_SET(PyTrilinos_MODULES  LOCA.Epetra.Interface)
  ENDIF(NOX_ENABLE_Epetra)
ENDIF(NOX_ENABLE_LOCA)

# Python interpreter and header files are required
FIND_PACKAGE(PythonInterp 2.5 REQUIRED)
FIND_PACKAGE(PythonInclude REQUIRED)

# Python module numpy is required
FIND_PACKAGE(NumPy 1.0 REQUIRED)

# Simple wrapper interface generator (SWIG) is required. SWIG 3.0.11
# is required to support the %module(moduleimport=...) option
SET(SWIG_VERSION_FLOOR   3.0.11)
FIND_PACKAGE(SWIG REQUIRED)
IF(${SWIG_VERSION} VERSION_LESS ${SWIG_VERSION_FLOOR})
  MESSAGE(FATAL_ERROR
    "SWIG version " ${SWIG_VERSION}
    " is less than minimum version " ${SWIG_VERSION_FLOOR}
    )
ENDIF()
# ${SWIG_USE_FILE} is hard-coded to be the installed UseSWIG.cmake
# file.  We want to include the local, modified version.
INCLUDE(UseSWIG)

# Python module mpi4py is optional, and only of interest if MPI is
# enabled
IF(TPL_ENABLE_MPI)
  SET(TPL_ENABLE_MPI4PY ON CACHE BOOL "Use Mpi4Py")
  IF(TPL_ENABLE_MPI4PY)
    FIND_PACKAGE(Mpi4Py)
  ELSE(TPL_ENABLE_MPI4PY)
    SET(Mpi4Py_FOUND OFF)
  ENDIF(TPL_ENABLE_MPI4PY)
ENDIF(TPL_ENABLE_MPI)

# Python module petsc4py is required if NOX_ENABLE_PETSC is true
IF(NOX_ENABLE_PETSC)
  FIND_PACKAGE(PETSc4Py REQUIRED)
ENDIF(NOX_ENABLE_PETSC)

# Print the enabled PyTrilinos packages
MESSAGE(STATUS "Enabled PyTrilinos packages:")
MESSAGE(STATUS "    ${PyTrilinos_PACKAGES}")

# Determine the PyTrilinos default installation directory prefix.  If
# CMAKE_INSTALL_PREFIX is set by the user, then use it.  Else the
# prefix is set to the value of python's sys.prefix.
EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c "import sys; print(sys.prefix)"
  OUTPUT_VARIABLE PYTHON_PREFIX
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )
IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  SET(PyTrilinos_DEFAULT_INSTALL_PREFIX ${PYTHON_PREFIX})
ELSE(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  SET(PyTrilinos_DEFAULT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

# Set the PyTrilinos install prefix
SET(PyTrilinos_INSTALL_PREFIX ${PyTrilinos_DEFAULT_INSTALL_PREFIX}
  CACHE PATH "The path prefix for where PyTrilinos will be installed, e.g. /usr/local")

# The default status for whether we build docstrings for PyTrilinos is
# based on whether the user has doxygen installed.
FIND_PACKAGE(Doxygen)
IF(DOXYGEN_FOUND)
  IF(${DOXYGEN_VERSION} VERSION_EQUAL 1.8.13 AND PyTrilinos_DOCSTRINGS)
    MESSAGE(FATAL_ERROR 
      "Doxygen version ${DOXYGEN_VERSION} has a bug that makes it incompatible with "
      "PyTrilinos. To work around this, you may disable PyTrilinos docstrings by setting "
      "PyTrilinos_DOCSTRINGS=OFF. "
      "Alternatively, you may choose to use a different version of doxygen. If you "
      "choose this route, be sure that the new version of doxygen is found first in "
      "your environment path.")
  ELSE(${DOXYGEN_VERSION} VERSION_EQUAL 1.8.13 AND PyTrilinos_DOCSTRINGS)
    SET(PyTrilinos_DOCSTRINGS_DEFAULT ON)
  ENDIF(${DOXYGEN_VERSION} VERSION_EQUAL 1.8.13 AND PyTrilinos_DOCSTRINGS)
ELSE(DOXYGEN_FOUND)
  SET(PyTrilinos_DOCSTRINGS_DEFAULT OFF)
  MESSAGE(STATUS "doxygen not found!")
ENDIF(DOXYGEN_FOUND)

# Set the PyTrilinos docstrings flag
SET(PyTrilinos_DOCSTRINGS ${PyTrilinos_DOCSTRINGS_DEFAULT} CACHE BOOL
    "a flag that determines whether Python docstrings will be built using doxygen")
IF(PyTrilinos_DOCSTRINGS AND NOT DOXYGEN_FOUND)
  MESSAGE(ERROR "PyTrilinos docstrings enabled but doxygen not found")
ENDIF(PyTrilinos_DOCSTRINGS AND NOT DOXYGEN_FOUND)

# Add the util directory
ADD_SUBDIRECTORY(util)

# Add the doc directory, which builds the python documentation strings
ADD_SUBDIRECTORY(doc)

# Add the src directory, which builds the pytrilinos library,
# generates the wrapper code, builds the PyTrilinos python package and
# compiles the PyTrilinos extension modules
ADD_SUBDIRECTORY(src)

# Add the test scripts
TRIBITS_ADD_TEST_DIRECTORIES(test)

# Add the example scripts
TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# Exclude files for source package.
#
TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

# Execute the package postprocessing
TRIBITS_PACKAGE_POSTPROCESS()

=== packages/amesos/CMakeLists.txt ===


#
# A) Define the package
#

TRIBITS_PACKAGE(Amesos)

#
# B) Set up package-specific options
#

# if using SuperLUDist, must also link in ParMETIS for some reason
IF(${PACKAGE_NAME}_ENABLE_SuperLUDist AND NOT ${PACKAGE_NAME}_ENABLE_ParMETIS)
  MESSAGE(FATAL_ERROR "The Amesos support for the SuperLUIDist TPL requires the ParMETIS TPL.  Either disable Amesos SuperLUDist support or enable the ParMETIS TPL.")
ENDIF()

IF(${PACKAGE_NAME}_ENABLE_PARAKLETE)
  MESSAGE(FATAL_ERROR "Support for the PARAKLETE package has been removed from Amesos.")
ENDIF()

# if using MUMPS, must be parallel
IF(${PACKAGE_NAME}_ENABLE_MUMPS)
IF(NOT TPL_ENABLE_MPI)
   
   MESSAGE(WARNING "\n\n*** Amesos does not support MUMPS without MPI ** \n\n")
   
   SET(${PACKAGE_NAME}_ENABLE_MUMPS OFF)

ENDIF()
ENDIF()

# if using parallel MUMPS, must also link in scalapack and BLACS

IF(${PACKAGE_NAME}_ENABLE_MUMPS AND ${PACKAGE_NAME}_ENABLE_MPI AND NOT ${PACKAGE_NAME}_ENABLE_SCALAPACK)
  MESSAGE(FATAL_ERROR "The Amesos support for parallel MUMPS requires SCALAPACK.")
ENDIF()

IF(${PACKAGE_NAME}_ENABLE_MUMPS AND ${PACKAGE_NAME}_ENABLE_MPI AND NOT ${PACKAGE_NAME}_ENABLE_BLACS)
  MESSAGE(FATAL_ERROR "The Amesos support for parallel MUMPS requires BLACS.")
ENDIF()


# if using SuperLU_5.0, must use the proper API
IF(${PACKAGE_NAME}_ENABLE_SuperLU)
  IF(NOT ${PROJECT_NAME}_ENABLE_SuperLU5_API)

   SET(HAVE_AMESOS_SUPERLU5_API OFF)

  ELSE()

   SET(HAVE_AMESOS_SUPERLU5_API ON)

  ENDIF()
ENDIF()

## Most of the options below are bogus.  The handling of TPLs is done
## through the dependencies file.  This needs to be cleaned up. I'm
## leaving them for now so that we have a list of all options.  They
## will be removed as correct TPL support is added.

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_DSCPACK
  HAVE_AMESOS_DSCPACK
  "Enable DSCPACK functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_MC64
  HAVE_AMESOS_MC64
  "Enable MC64 functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_KLU
  HAVE_AMESOS_KLU
  "Enable KLU (Tim Davis's Files)."
  ON )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PARDISO
  HAVE_AMESOS_PARDISO
  "Enable PARDISO functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PARDISO_MKL
  HAVE_AMESOS_PARDISO_MKL
  "Enable PARDISO functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PARAKLETE
  HAVE_AMESOS_PARAKLETE
  "Enable PARAKLETE functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_LAPACK
  HAVE_AMESOS_LAPACK
  "Enable LAPACK functionality."
  ON )
  
# ...

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

TRIBITS_EXCLUDE_FILES(
  doc/AmesosOverview
  doc/PARA06
  example/RunParaklete.cpp
  example/Thyra_AmesosLinearOpWithSolveFactory.cpp
  example/pk.h
  example/run_pk.c
  example/simpleStratimikosSolve.cpp
  example/simpleStratimikosSolve.hpp
  example/stratimikos_example.cpp
  src/Amesos_BTF.h
  src/Amesos_Component.h
  src/Amesos_Merikos.h
  src/Amesos_BTF.h
  src/src-repository
  src/stamp-h.in
  test/TestOptions/Dummy
  test/Test_Basic/NotQuiteDense.triU
  test/Test_Performance/In_Test_UmfpackPerformance.csh
  test/scripts/daily/mpi/TestBasic.sh
  test/scripts/daily/serial/TestAmesos.sh
  )

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/amesos2/CMakeLists.txt ===

#
# A) Define the package
#

TRIBITS_PACKAGE(Amesos2)

SET(${PACKAGE_NAME_UC}_VERSION "0.3d")
SET(${PACKAGE_NAME_UC}_RELEASE_DATE "07/28/2011")

#
# B) Set up package-specific options
#

IF (NOT Tpetra_INST_INT_INT)

   MESSAGE(WARNING "*****Amesos2 will not provide Epetra Matrix Support with Tpetra_INST_INT_INT OFF.*****")
   MESSAGE(WARNING "*****Amesos2 will not provide MUMPS Support with Tpetra_INST_INT_INT OFF.*****")


ENDIF ()

IF (Amesos2_ENABLE_UMFPACK)
  IF (Trilinos_ENABLE_COMPLEX_FLOAT AND NOT Trilinos_ENABLE_COMPLEX_DOUBLE)
    MESSAGE(WARNING "*****Amesos2 is building Umfpack without a complex<double> type. Umfpack natively supports only complex<double> types, not complex<float> types, and this will lead to type conversions. *****")
  ENDIF()
  # This may not happen anyways… right now it seems we can’t compile this package with Trilinos_ENABLE_FLOAT and TPetra_INST_DOUBLE turned off - need to resolve.
  IF (NOT Tpetra_INST_DOUBLE)
    MESSAGE(WARNING "*****Amesos2 is building Umfpack without a double type. Umfpack natively supports only double types, not float types, and this will lead to type conversions. *****")
  ENDIF()
ENDIF()


# if using SuperLU_5.0, must use the proper API
IF(${PACKAGE_NAME}_ENABLE_SuperLU)
  IF(NOT ${PROJECT_NAME}_ENABLE_SuperLU5_API)

   SET(HAVE_AMESOS2_SUPERLU5_API OFF)

  ELSE()

   SET(HAVE_AMESOS2_SUPERLU5_API ON)

  ENDIF()
ENDIF()


TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_VERBOSE_DEBUG
  HAVE_${PACKAGE_NAME_UC}_VERBOSE_DEBUG
  "Enable verbose output during debug-mode"
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_TIMERS
  HAVE_${PACKAGE_NAME_UC}_TIMERS
  "Enable performance timers"
  OFF )

#
# TPL Solver interfaces are enabled automatically based on Trilinos
# TPL configuration.
#
# Config options such as Amesos2_ENABLE_XXXXXX are automatically
# generated in case a user would wish to explicitely disable Amesos2
# support for an otherwise enabled third-part solver library
#


IF(${PACKAGE_NAME}_ENABLE_Cholmod)
  SET(HAVE_AMESOS2_CHOLMOD ON )
ENDIF()


TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_LAPACK
  HAVE_${PACKAGE_NAME_UC}_LAPACK
  "Enable the dense serial solver interface"
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_KLU2
  HAVE_AMESOS2_KLU2
  "Enable KLU2 in Amesos2"
  ON
)

IF (Trilinos_ENABLE_ShyLU_NodeTacho AND NOT Kokkos_ENABLE_Cuda)
  SET(Amesos2_HAVE_TACHO ON)
ELSE()
  SET(Amesos2_HAVE_TACHO OFF)
ENDIF()

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_ShyLU_NodeTacho
  HAVE_AMESOS2_TACHO
  "Enable Tacho in Amesos2"
  ${Amesos2_HAVE_TACHO}
)

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_Basker
   HAVE_AMESOS2_BASKER
   "Enable Basker in Amesos2"
   OFF
)

IF (Trilinos_ENABLE_ShyLU_NodeBasker AND Kokkos_ENABLE_OpenMP AND NOT Kokkos_ENABLE_Cuda)
  SET(Amesos2_HAVE_SHYLUBASKER ON)
ELSE()
  SET(Amesos2_HAVE_SHYLUBASKER OFF)
ENDIF()

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_ShyLU_NodeBasker
  HAVE_AMESOS2_SHYLUBASKER
  "Enable ShyLUBasker in Amesos2"
  ${Amesos2_HAVE_SHYLUBASKER}
)

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_MUMPS
  HAVE_AMESOS2_MUMPS
  "Enable MUMPS in Amesos2"
  OFF
)

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_Experimental
  HAVE_AMESOS2_EXPERIMENTAL
  "Enable building and installation of experimental Amesos2 features."
  NO 
)

TRIBITS_ADD_DEBUG_OPTION()

TRIBITS_ADD_EXPLICIT_INSTANTIATION_OPTION()

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# D) Do standard postprocessing
#

#leaving in place for future excludes
#TRIBITS_EXCLUDE_FILES(
#  )

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/belos/CMakeLists.txt ===

######################################################################
## Define the package
######################################################################

TRIBITS_PACKAGE(Belos)

######################################################################
## Set up package-specific options
######################################################################

TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

# Kokkos includes an implementation of the Tall Skinny QR (TSQR)
# factorization.  TSQR is used to implement an OrthoManager and a
# MatOrthoManager (which only uses TSQR in the Euclidean-inner-product
# case).  TSQR is enabled by default if the KokkosTSQR and Tpetra
# packages are enabled, but users have control over
# Tpetra_ENABLE_TSQR.  Note that the Epetra adapter for TSQR currently
# lives in Tpetra.
#
# mfh 05 Sep 2012: Back in 2010, I had to put Epetra's TSQR adapter in
# Tpetra.  This was because an external software package was linking
# to Epetra without using Trilinos' Makefile.export mechanism to
# consider which Trilinos libraries to use.  Making Epetra optionally
# depend on Kokkos (to make TSQR work) changed the list of libraries,
# and that software package wasn't doing the right thing to adjust.
# In any case, I chose at the time to put Epetra's TSQR adapter in
# Tpetra, since Tpetra already had an optional dependency on Epetra.
# So, for better or worse, you won't be able to use TSQR with Epetra
# unless you enable both Epetra and Tpetra in your Trilinos build.
# HAVE_BELOS_TSQR will correctly reflect this: it won't be defined 
# unless both Epetra and Tpetra are enabled in your Trilinos build.
IF (${PACKAGE_NAME}_ENABLE_Epetra AND ${PACKAGE_NAME}_ENABLE_Tpetra AND Tpetra_ENABLE_TSQR)
  GLOBAL_SET(${PACKAGE_NAME}_ENABLE_TSQR_DEFAULT ON)
ELSE()
  GLOBAL_SET(${PACKAGE_NAME}_ENABLE_TSQR_DEFAULT OFF)
ENDIF()
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_TSQR
  HAVE_BELOS_TSQR
  "Enable TSQR (Tall Skinny QR factorization) as an orthogonalization method in Belos.  You must build Trilinos with both Epetra _and_ Tpetra enabled in order to use TSQR with Epetra objects."
  "${${PACKAGE_NAME}_ENABLE_TSQR_DEFAULT}")

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_TEUCHOS_TIME_MONITOR
  BELOS_TEUCHOS_TIME_MONITOR
  "Enable Teuchos timers (via TimeMonitor) in Belos solvers."
  ${${PROJECT_NAME}_ENABLE_TEUCHOS_TIME_MONITOR} )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_Tpetra_Timers
  HAVE_BELOS_TPETRA_TIMERS
  "Add timers to Belos::MultiVecTraits for Tpetra::MultiVector operations."
  NO )

#
# "Experimental" code lives in Belos, but is not quite ready for use
# by a general audience.  You have to enable the CMake option below in
# order to install experimental headers, include experimental source
# files in the libraries, and build experimental tests.
#
# It's up to Belos developers to define what headers and source files
# are experimental, and what tests depend on experimental code.  They
# must use ${PACKAGE_NAME}_ENABLE_Experimental to conditionally
# disable tests or examples that have a required dependency on
# experimental code.  (${PACKAGE_NAME} evaluates to Belos, but we
# write it out so you know what to look for in the file.)  Code that
# _optionally_ depends on experimental code must be protected by
# #ifdef HAVE_BELOS_EXPERIMENTAL ... #endif.
#
# Belos developers must maintain the lists of experimental header
# resp. source files in belos/src/CMakeLists.txt, as
# ${PACKAGE_NAME}_EXPERIMENTAL_HEADERS
# resp. ${PACKAGE_NAME}_EXPERIMENTAL_SOURCES.
#
# Note that some experimental files may be excluded from the release
# tarball.  Belos uses the TRIBITS_EXCLUDE_FILES macro later in
# this file to list the files and directories to exclude from the
# release tarball.  That macro must NOT include conditional
# expressions; it must evaluate to the same list, no matter how
# Trilinos is configured.  We ensure this in Belos by listing
# explicitly the files and directories to exclude from the release
# tarball, rather than using variables or conditional CMake
# expressions.
#
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_Experimental
  HAVE_BELOS_EXPERIMENTAL
  "Enable experimental Belos solvers and features."
  NO )

# See above discussion of "experimental" Belos headers and source
# files.  belos/src/CMakeLists.txt may append to these lists.
SET(${PACKAGE_NAME}_EXPERIMENTAL_HEADERS "")
SET(${PACKAGE_NAME}_EXPERIMENTAL_SOURCES "")


######################################################################
## Add the libraries, tests, and examples
######################################################################

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

IF (Belos_ENABLE_Epetra)
  ADD_SUBDIRECTORY(epetra)
ENDIF()

IF (Belos_ENABLE_Tpetra)
  ADD_SUBDIRECTORY(tpetra)
ENDIF()

IF (Belos_ENABLE_Xpetra)
  ADD_SUBDIRECTORY(xpetra)
ENDIF()

# Do this after building the libs - we need them
ADD_SUBDIRECTORY(doc)

######################################################################
## Build list of files to exclude from the release tarball
######################################################################

#
# Exclude leftover GNU Autotools files.
#
TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

#
# Files and directories to exclude from the release tarball.
#
TRIBITS_EXCLUDE_FILES(
  src/BelosInnerSolveResult.hpp
  src/BelosInnerSolver.hpp
  src/BelosProjectedLeastSquaresSolver.hpp
  src/BelosInnerSolveResult.cpp
  test/ProjectedLeastSquaresSolver
)

######################################################################
## Do standard postprocessing
######################################################################

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/claps/CMakeLists.txt ===


#
# A) Define the package
#

TRIBITS_PACKAGE(Claps)

#
# B) Set up package-specific options
#

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_SClaps
  HAVE_SCLAPS
  "Enable Sandia Claps interface."
  OFF )

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

#TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/fei/CMakeLists.txt ===


#
# A) Define the package
#

TRIBITS_PACKAGE(FEI)

TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

#
# B) Set up package-specific options
#

IF (${PACKAGE_NAME}_ENABLE_Epetra)
  TRIBITS_ADD_OPTION_AND_DEFINE(
    FEI_EPETRA
    HAVE_FEI_EPETRA
    "FEI support for Epetra"
    ${${PACKAGE_NAME}_ENABLE_Epetra}
  )
ENDIF()

IF (${PACKAGE_NAME}_ENABLE_AztecOO)
  TRIBITS_ADD_OPTION_AND_DEFINE(
    FEI_AZTECOO
    HAVE_FEI_AZTECOO
    "FEI support for AztecOO"
    ${${PACKAGE_NAME}_ENABLE_AztecOO}
  )
ENDIF()

IF (${PACKAGE_NAME}_ENABLE_Belos)
  TRIBITS_ADD_OPTION_AND_DEFINE(
    FEI_BELOS
    HAVE_FEI_BELOS
    "FEI support for Belos"
    ${${PACKAGE_NAME}_ENABLE_Belos}
  )
ENDIF()

IF (${PACKAGE_NAME}_ENABLE_Amesos)
    TRIBITS_ADD_OPTION_AND_DEFINE(
      FEI_AMESOS
      HAVE_FEI_AMESOS
      "FEI support for Amesos"
      ${${PACKAGE_NAME}_ENABLE_Amesos}
    )
ENDIF()

IF (${PACKAGE_NAME}_ENABLE_Tpetra)
  TRIBITS_ADD_OPTION_AND_DEFINE(
    FEI_TPETRA
    HAVE_FEI_TPETRA
    "FEI support for Tpetra"
    ${${PACKAGE_NAME}_ENABLE_Tpetra}
  )
ENDIF()

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(base)
ADD_SUBDIRECTORY(support-Trilinos)
ADD_SUBDIRECTORY(test_utils)


TRIBITS_ADD_TEST_DIRECTORIES(test)
TRIBITS_ADD_TEST_DIRECTORIES(unit_tests_base)
TRIBITS_ADD_TEST_DIRECTORIES(unit_tests)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/ifpack2/CMakeLists.txt ===
#
# Define the package
#
TRIBITS_PACKAGE( Ifpack2 )

# If deprecated warnings are on, and the compiler supports them, then
# define IFPACK2_DEPRECATED to emit deprecated warnings.  Otherwise,
# give it an empty definition.
TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

#
# Set up package-specific options
#

#
# Do explicit template instantiation (ETI) and testing over the same
# Scalar, LocalOrdinal, and GlobalOrdinal types as for Tpetra objects.
# However, by default, exclude all of Tpetra's GlobalOrdinal (GO)
# types from the ETI list.  This is because Tpetra adds all GO ETI
# types to the list of Scalar ETI types.  (This lets it implement
# certain communication patterns involving e.g., Vector<GO, LO, GO>.)
#

# Make sure that Tpetra actually defined these variables, even if they
# are empty.
ASSERT_DEFINED(TpetraCore_ETI_SCALARS)
ASSERT_DEFINED(TpetraCore_ETI_LORDS)
ASSERT_DEFINED(TpetraCore_ETI_GORDS)
ASSERT_DEFINED(TpetraCore_ETI_NODES)

# Exclude GlobalOrdinal types from the list of Scalar types over which
# Ifpack2 does ETI.
#
# Look at each entry in Tpetra's list of ETI Scalar types.  If it is
# also a Tpetra ETI GlobalOrdinal type, don't append it to Ifpack2's
# list of ETI Scalar types.  Otherwise, do.
SET (Ifpack2_ETI_SCALARS_TEMP ) # start with the empty list
FOREACH (scalarName IN LISTS TpetraCore_ETI_SCALARS)
  LIST (FIND TpetraCore_ETI_GORDS ${scalarName} scalarNameIndex)
  IF (-1 EQUAL scalarNameIndex) # not in the list of integer types
    LIST (APPEND Ifpack2_ETI_SCALARS_TEMP ${scalarName})
  ENDIF ()
ENDFOREACH ()

SET(Ifpack2_ETI_SCALARS ${Ifpack2_ETI_SCALARS_TEMP})
SET(Ifpack2_ETI_LORDS   ${TpetraCore_ETI_LORDS})
SET(Ifpack2_ETI_GORDS   ${TpetraCore_ETI_GORDS})
SET(Ifpack2_ETI_NODES   ${TpetraCore_ETI_NODES})

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_Trilinos
  HAVE_${PACKAGE_NAME}_Trilinos
  "Building as a Trilinos package"
  ON
  )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_DEBUG
  HAVE_${PACKAGE_NAME}_DEBUG
  "Enable runtime debug checking."
  ${${PROJECT_NAME}_ENABLE_DEBUG}
  )

TRIBITS_ADD_EXPLICIT_INSTANTIATION_OPTION()

# we use this for testing as well as library eti, so do it regardless
TRIBITS_ADD_ETI_SUPPORT()

#Adding a define for when the TPL QD is enabled.
#This replaces an option that was reusing an existing name.
SET(HAVE_${PACKAGE_NAME}_QD "${PACKAGE_NAME}_ENABLE_QD")

#Adding an option and define when MPI is enabled.
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_MPI
  HAVE_IFPACK2_MPI
  "Enable MPI build of Ifpack2."
  ${TPL_ENABLE_MPI} )

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_Lemon)
ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_Amesos2)
ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_Cholmod)
IF(${PACKAGE_NAME}_ENABLE_Lemon AND ${PACKAGE_NAME}_ENABLE_Amesos2 AND ${PACKAGE_NAME}_ENABLE_Cholmod)
  SET(HAVE_IFPACK2_SUPPORTGRAPH ON )
ENDIF()

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_Experimental	
  HAVE_IFPACK2_EXPERIMENTAL
  "Enable building and installation of experimental Ifpack2 features."
  NO )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_DEPRECATED_CODE
  HAVE_IFPACK2_DEPRECATED_CODE
  "Enable building and installation of long deprecated Ifpack2 code.  This is OFF by default.  DO NOT ENABLE THIS UNLESS YOU INSIST ON BUILDING DEPRECATED CODE.  You may see lots of deprecated warnings if you enable this.  That's your problem; you wanted to use the code."
  NO )

# mfh 04 Jan 2017: Per #288, we want to enable this code by default.
SET (${PACKAGE_NAME}_ENABLE_Experimental_KokkosKernels_Features_DEFAULT ON)

ASSERT_DEFINED (${PACKAGE_NAME}_ENABLE_Experimental_KokkosKernels_Features_DEFAULT)
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_Experimental_KokkosKernels_Features
  HAVE_IFPACK2_EXPERIMENTAL_KOKKOSKERNELS_FEATURES
  "Enable building and installation of some Ifpack2 features that use new KokkosKernels features."
  "${${PACKAGE_NAME}_ENABLE_Experimental_KokkosKernels_Features_DEFAULT}"
  )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_IFPACK2_TIMER_BARRIER
  HAVE_IFPACK2_TIMER_BARRIER
  "Enables a barrier in Ifpack2 Additive Schwarz so that timing information is useful"
  NO )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_BlockTriDiContainer_Timers
  HAVE_IFPACK2_BLOCKTRIDICONTAINER_TIMERS
  "Turn on timers in Ifpack2::BlockTriDiContainer."
  NO )

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(adapters)

TRIBITS_ADD_TEST_DIRECTORIES(test)
TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

# Promote these variables to be visible outside of the "scope" of this
# directory -- e.g., to other packages.
GLOBAL_SET(Ifpack2_ETI_SCALARS ${Ifpack2_ETI_SCALARS})
GLOBAL_SET(Ifpack2_ETI_LORDS   ${Ifpack2_ETI_LORDS})
GLOBAL_SET(Ifpack2_ETI_GORDS   ${Ifpack2_ETI_GORDS})
GLOBAL_SET(Ifpack2_ETI_NODES   ${Ifpack2_ETI_NODES})

#
# Exclude files for source package.
#


#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/intrepid/CMakeLists.txt ===


#
# A) Define the package
#

TRIBITS_PACKAGE(Intrepid)

#
# B) Set up package-specific options
#

SET(INTREPID_OLD_KOKKOS_CODE FALSE)

IF(Amesos_ENABLE_UMFPACK)
  SET(${PACKAGE_NAME}_ENABLE_AMESOS_UMFPACK_DEFAULT ON)
ELSE()
  SET(${PACKAGE_NAME}_ENABLE_AMESOS_UMFPACK_DEFAULT OFF)
ENDIF()

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_AMESOS_UMFPACK
  HAVE_INTREPID_AMESOS_UMFPACK
  "Enable Amesos with UmfPack functionality."
  ${Intrepid_ENABLE_AMESOS_UMFPACK_DEFAULT} )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_DEBUG
  HAVE_INTREPID_DEBUG
  "Enable a host of runtime debug checking."
  ${${PROJECT_NAME}_ENABLE_DEBUG}
  )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_DEBUG_INF_CHECK
  HAVE_INTREPID_DEBUG_INF_CHECK
  "Enable a host of runtime debug checking for infs and nans."
  ${${PROJECT_NAME}_ENABLE_DEBUG}
  )

#TRIBITS_PROCESS_SUBPACKAGES()

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/kokkos-kernels/CMakeLists.txt ===
INCLUDE(TribitsETISupport)

#
# Define the package
#
TRIBITS_PACKAGE(KokkosKernels)

# If building in debug mode, define the HAVE_KOKKOSKERNELS_DEBUG macro.
TRIBITS_ADD_DEBUG_OPTION()

#
# Set up subpackage-specific configuration options
#

#
# "Optimization level" for KokkosKernels computational kernels.  The
# higher the level, the more code variants get generated, and thus the
# longer the compile times.  However, more code variants mean both
# better performance overall, and more uniform performance for corner
# cases.  Values of current interest (24 Apr 2014) are 0, 1, and 2.
#
TRIBITS_ADD_OPTION_AND_DEFINE( KokkosLinAlg_Opt_Level
  KOKKOSLINALG_OPT_LEVEL
  "Optimization level for KokkosKernels computational kernels: a nonnegative integer.  Higher levels result in better performance that is more uniform for corner cases, but increase build time and library size.  The default value is 1, which should give performance within ten percent of optimal on most platforms, for most problems."
  "1"
  )



# Enable experimental features of KokkosKernels if set at configure
# time. Default is no.
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_Experimental
  HAVE_KOKKOSKERNELS_EXPERIMENTAL
  "Enable building and installation of experimental KokkosKernels features."
  NO )

# Define what execution spaces KokkosKernels enables.
# KokkosKernels may enable fewer execution spaces than
# Kokkos enables.  This can reduce build and test times.

ASSERT_DEFINED (Kokkos_ENABLE_Cuda)
SET(${PACKAGE_NAME}_INST_EXECSPACE_CUDA_DEFAULT ${Kokkos_ENABLE_Cuda})
ASSERT_DEFINED (Kokkos_ENABLE_OpenMP)
SET(${PACKAGE_NAME}_INST_EXECSPACE_OPENMP_DEFAULT ${Kokkos_ENABLE_OpenMP})
ASSERT_DEFINED (Kokkos_ENABLE_Pthread)
SET(${PACKAGE_NAME}_INST_EXECSPACE_THREADS_DEFAULT ${Kokkos_ENABLE_Pthread})
ASSERT_DEFINED (Kokkos_ENABLE_Serial)
SET(${PACKAGE_NAME}_INST_EXECSPACE_SERIAL_DEFAULT ${Kokkos_ENABLE_Serial})

IF(${Kokkos_ENABLE_Cuda})
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_EXECSPACE_CUDA
  KOKKOSKERNELS_INST_EXECSPACE_CUDA
  "Whether to pre instantiate kernels for the execution space Kokkos::Cuda.  This option is KokkosKernels_INST_EXECSPACE_CUDA=${Kokkos_ENABLE_Cuda} by default.  Disabling this when Kokkos_ENABLE_Cuda is enabled may increase build times."
  ${${PACKAGE_NAME}_INST_EXECSPACE_CUDA_DEFAULT}
  )
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_MEMSPACE_CUDAUVMSPACE
  KOKKOSKERNELS_INST_MEMSPACE_CUDAUVMSPACE
  "Whether to pre instantiate kernels for the memory space Kokkos::CudaUVMSpace.  This option is KokkosKernels_INST_EXECSPACE_CUDAUVMSPACE=${Kokkos_ENABLE_Cuda} by default.  Disabling this when Kokkos_ENABLE_Cuda is enabled may increase build times."
  ${${PACKAGE_NAME}_INST_EXECSPACE_CUDA_DEFAULT}
  )
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_MEMSPACE_CUDASPACE
  KOKKOSKERNELS_INST_MEMSPACE_CUDASPACE
  "Whether to pre instantiate kernels for the memory space Kokkos::CudaSpace.  This option is KokkosKernels_INST_EXECSPACE_CUDASPACE=${Kokkos_ENABLE_Cuda} by default.  Disabling this when Kokkos_ENABLE_Cuda is enabled may increase build times."
  ${${PACKAGE_NAME}_INST_EXECSPACE_CUDA_DEFAULT}
  )

  IF(${${PACKAGE_NAME}_INST_EXECSPACE_CUDA} AND ${${PACKAGE_NAME}_INST_MEMSPACE_CUDASPACE})
    LIST(APPEND DEVICE_LIST "<Cuda,CudaSpace>")
  ENDIF()
  IF(${${PACKAGE_NAME}_INST_EXECSPACE_CUDA} AND ${${PACKAGE_NAME}_INST_MEMSPACE_CUDAUVMSPACE})
    LIST(APPEND DEVICE_LIST "<Cuda,CudaUVMSpace>")
  ENDIF()

  IF( Trilinos_ENABLE_COMPLEX_DOUBLE AND ((NOT DEFINED CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS) OR (NOT CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS)) )
    MESSAGE( WARNING "The CMake option CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS is either undefined or OFF.  Please set CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS:BOOL=ON when building with CUDA and complex double enabled.")
  ENDIF()

ENDIF()

IF(${Kokkos_ENABLE_Serial} OR ${Kokkos_ENABLE_Pthread} OR ${Kokkos_ENABLE_OpenMP})
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_MEMSPACE_HOSTSPACE
  KOKKOSKERNELS_INST_MEMSPACE_HOSTSPACE
  "Whether to pre instantiate kernels for the memory space Kokkos::HostSpace.  This option is KokkosKernels_INST_EXECSPACE_HOSTSPACE=(${Kokkos_ENABLE_OpenMP} OR ${Kokkos_ENABLE_Pthread} OR ${Kokkos_ENABLE_Serial}) by default.  Disabling this when one of the Host execution spaces is enabled may increase build times."
  ON
  )
ENDIF()

IF(${Kokkos_ENABLE_OpenMP})
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_EXECSPACE_OPENMP
  KOKKOSKERNELS_INST_EXECSPACE_OPENMP
  "Whether to pre instantiate kernels for the execution space Kokkos::OpenMP.  This option is KokkosKernels_INST_EXECSPACE_OPENMP=${Kokkos_ENABLE_OpenMP} by default.  Disabling this when Kokkos_ENABLE_OpenMP is enabled may increase build times."
  ${${PACKAGE_NAME}_INST_EXECSPACE_OPENMP_DEFAULT}
  )
  IF(${${PACKAGE_NAME}_INST_EXECSPACE_OPENMP} AND ${${PACKAGE_NAME}_INST_MEMSPACE_HOSTSPACE})
    LIST(APPEND DEVICE_LIST "<OpenMP,HostSpace>")
  ENDIF()
ENDIF()


IF(${Kokkos_ENABLE_Pthread})
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_EXECSPACE_THREADS
  KOKKOSKERNELS_INST_EXECSPACE_THREADS
  "Whether to build kernels for the execution space Kokkos::Threads.  This option is Kokkos_ENABLE_Pthread=${Kokkos_ENABLE_Pthread} by default.  If explicit template instantiation (ETI) is enabled in Trilinos, disabling this when Kokkos_ENABLE_Pthread is enabled may increase build times."
  ${${PACKAGE_NAME}_INST_EXECSPACE_THREADS_DEFAULT}
  )
  IF(${${PACKAGE_NAME}_INST_EXECSPACE_THREADS} AND ${${PACKAGE_NAME}_INST_MEMSPACE_HOSTSPACE})
    LIST(APPEND DEVICE_LIST "<Threads,HostSpace>")
  ENDIF()
ENDIF()


IF(${Kokkos_ENABLE_Serial})
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_EXECSPACE_SERIAL
  KOKKOSKERNELS_INST_EXECSPACE_SERIAL
  "Whether to build kernels for the execution space Kokkos::Serial.  This option is Kokkos_ENABLE_Serial=${Kokkos_ENABLE_Serial} by default.  If explicit template instantiation (ETI) is enabled in Trilinos, disabling this when Kokkos_ENABLE_Serial is enabled may increase build times."
  ${${PACKAGE_NAME}_INST_EXECSPACE_SERIAL_DEFAULT}
  )
  IF(${${PACKAGE_NAME}_INST_EXECSPACE_SERIAL} AND ${${PACKAGE_NAME}_INST_MEMSPACE_HOSTSPACE})
    LIST(APPEND DEVICE_LIST "<Serial,HostSpace>")
  ENDIF()
ENDIF()

# ==================================================================
# Enable Scalar Types for ETI
# ==================================================================

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ETI_Only
  KOKKOSKERNELS_ETI_ONLY
  "Whether to restrict availability of kernels to ETI types only. This is off by default, i.e. any type combination can be instantiated. Turning this on guarantees that kernels are never build inside of object files which simply call KokkosKernels functions."
  OFF
  )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_Test_ETI_Only
  KOKKOSKERNELS_TEST_ETI_ONLY
  "Whether to restrict testing to ETI types."
  ON
  )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_DOUBLE
  KOKKOSKERNELS_INST_DOUBLE
  "Whether to pre instantiate kernels for the scalar type double.  This option is KokkosKernels_INST_DOUBLE=ON by default.  Disabling this may increase build times."
  ON
  )

IF (Trilinos_ENABLE_FLOAT)
  GLOBAL_SET(KokkosKernels_INST_FLOAT_DEFAULT  ON)
ELSE()
  GLOBAL_SET(KokkosKernels_INST_FLOAT_DEFAULT  OFF)
ENDIF()

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_FLOAT
  KOKKOSKERNELS_INST_FLOAT
  "Whether to pre instantiate kernels for the scalar type float.  This option is KokkosKernels_INST_FLOAT=Trilinos_ENABLE_FLOAT by default.  Disabling this may increase build times."
  ${KokkosKernels_INST_FLOAT_DEFAULT}
  )

IF (KokkosKernels_INST_DOUBLE AND Trilinos_ENABLE_COMPLEX_DOUBLE)
  GLOBAL_SET(KokkosKernels_INST_COMPLEX_DOUBLE_DEFAULT ON)
ELSE()
  GLOBAL_SET(KokkosKernels_INST_COMPLEX_DOUBLE_DEFAULT OFF)
ENDIF()
IF (KokkosKernels_INST_FLOAT AND Trilinos_ENABLE_COMPLEX_FLOAT)
  GLOBAL_SET(KokkosKernels_INST_COMPLEX_FLOAT_DEFAULT ON)
ELSE()
  GLOBAL_SET(KokkosKernels_INST_COMPLEX_FLOAT_DEFAULT OFF)
ENDIF()

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_COMPLEX_DOUBLE
  KOKKOSKERNELS_INST_COMPLEX_DOUBLE
  "Whether to pre instantiate kernels for the scalar type complex<double>.  This option is KokkosKernels_INST_COMPLEX_DOUBLE=${Trilinos_ENABLE_COMPLEX_DOUBLE} by default.  Disabling this may increase build times."
  ${KokkosKernels_INST_COMPLEX_DOUBLE_DEFAULT}
  )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_COMPLEX_FLOAT
  KOKKOSKERNELS_INST_COMPLEX_FLOAT
  "Whether to pre instantiate kernels for the scalar type complex<float>.  This option is KokkosKernels_INST_COMPLEX_FLOAT=${Trilinos_ENABLE_COMPLEX_FLOAT} by default.  Disabling this may increase build times."
  ${KokkosKernels_INST_COMPLEX_FLOAT_DEFAULT}
  )

IF (KokkosKernels_INST_DOUBLE)
  LIST(APPEND SCALAR_LIST "double")
ENDIF()

IF (KokkosKernels_INST_FLOAT)
  LIST(APPEND SCALAR_LIST "float")
ENDIF()

IF (KokkosKernels_INST_COMPLEX_DOUBLE)
  LIST(APPEND SCALAR_LIST "complex<double>")
ENDIF()

IF (KokkosKernels_INST_FLOAT)
  LIST(APPEND SCALAR_LIST "complex<float>")
ENDIF()


TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_LAYOUTLEFT
  KOKKOSKERNELS_INST_LAYOUTLEFT
  "Whether to pre instantiate kernels for the view layout LayoutLeft.  This option is KokkosKernels_INST_LAYOUTLEFT=ON by default.  Disabling this may increase build times."
  ON
  )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_LAYOUTRIGHT
  KOKKOSKERNELS_INST_LAYOUTRIGHT
  "Whether to pre instantiate kernels for the view layout LayoutRight.  This option is KokkosKernels_INST_LAYOUTRIGHT=OFF by default.  Disabling this may increase build times."
  OFF
  )

# ==================================================================
# Enable Ordinal Types for ETI
# ==================================================================


GLOBAL_SET(KokkosKernels_INST_ORDINAL_INT_DEFAULT  ON)
GLOBAL_SET(KokkosKernels_INST_ORDINAL_INT64_T_DEFAULT  OFF)


TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_ORDINAL_INT
  KOKKOSKERNELS_INST_ORDINAL_INT
  "Whether to pre instantiate kernels for the ordinal type int.  This option is KokkosKernels_INST_ORDINAL_INT=ON by default."
  ${KokkosKernels_INST_ORDINAL_INT_DEFAULT}
  )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_ORDINAL_INT64_T
  KOKKOSKERNELS_INST_ORDINAL_INT64_T
  "Whether to pre instantiate kernels for the ordinal type int64_t.  This option is KokkosKernels_INST_ORDINAL_INT64_T=OFF by default."
  ${KokkosKernels_INST_ORDINAL_INT64_T_DEFAULT}
  )

IF (KokkosKernels_INST_ORDINAL_INT)
  LIST(APPEND ORDINAL_LIST "int")
ENDIF()

IF (KokkosKernels_INST_ORDINAL_INT64_T)
  LIST(APPEND ORDINAL_LIST "int64_t")
ENDIF()


# ==================================================================
# Enable Offset Types for ETI
# ==================================================================


GLOBAL_SET(KokkosKernels_INST_OFFSET_SIZE_T_DEFAULT  ON)
GLOBAL_SET(KokkosKernels_INST_OFFSET_INT_DEFAULT  ON)
#GLOBAL_SET(KokkosKernels_INST_OFFSET_INT64_T_DEFAULT  OFF)


TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_OFFSET_INT
  KOKKOSKERNELS_INST_OFFSET_INT
  "Whether to pre instantiate kernels for the offset type int.  This option is KokkosKernels_INST_OFFSET_INT=ON by default."
  ${KokkosKernels_INST_OFFSET_INT_DEFAULT}
  )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_INST_OFFSET_SIZE_T
  KOKKOSKERNELS_INST_OFFSET_SIZE_T
  "Whether to pre instantiate kernels for the offset type size_t.  This option is KokkosKernels_INST_OFFSET_SIZE_T=OFF by default."
  ${KokkosKernels_INST_OFFSET_SIZE_T_DEFAULT}
  )

IF (KokkosKernels_INST_OFFSET_INT)
  LIST(APPEND OFFSET_LIST "int")
ENDIF()

IF (KokkosKernels_INST_OFFSET_SIZE_T)
  LIST(APPEND OFFSET_LIST "size_t")
ENDIF()

# ==================================================================
# Enable Third Party Libraries
# ==================================================================

IF (TPL_ENABLE_BLAS)

=== debian/changelog ===
trilinos (12.14.1-3) unstable; urgency=medium

  [ Graham Inggs]
  * Limit to 2 parallel build jobs
  * Remove temporary files after dh_install

  [  Matthias Maier ]
  * Disable failing unit tests
  * Update maintainers in control file

 -- Graham Inggs <ginggs@debian.org>  Thu, 27 Feb 2020 16:06:46 +0000

trilinos (12.14.1-2) unstable; urgency=medium

  [ Nico Schlömer ]
  * Fix multi-arch issue with Kokkos
  * Add Intrepid 2 (Closes: #944688)

  [ Graham Inggs ]
  * Add iframeResizer v2.3.1 sources to debian/missing-sources
  * Add Breaks and Replaces on libtrilinos-muelu-dev (<< 12.14)
    to libtrilinos-belos-dev (Closes: #944486)
  * Double up the limit of debug information entries

 -- Nico Schlömer <nico.schloemer@gmail.com>  Tue, 24 Dec 2019 13:24:19 +0000

trilinos (12.14.1-1) unstable; urgency=medium

  * Update to 12.14.1
  * Remove obsolete patch
  * Update debian/watch
  * add metadata file
  * [23b3efc6] remove Python 2 dependency (Closes: #943292)
  * Fix ShyLu builds (Graham Inggs)
  * Add dependency on bc
  * Bump standards to 4.4.1

 -- Nico Schlömer <nico.schloemer@gmail.com>  Sat, 02 Nov 2019 06:36:02 +0000

=== debian/control ===
Source: trilinos
Homepage: https://trilinos.github.io/
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>,
           Graham Inggs <ginggs@debian.org>,
Build-Depends: debhelper-compat (= 12),
 cmake (>= 2.8.11),
 gfortran,
 libopenmpi-dev,
 libblas-dev,
 libboost-dev,
 libboost-system-dev,
 libboost-program-options-dev,
 libglm-dev,
 libhdf5-openmpi-dev,
 liblapack-dev,
 libmumps-dev (>= 4.10),
 libptscotch-dev (>= 6.0.3),
 libtbb-dev,
 openmpi-bin,
 zlib1g-dev
Build-Depends-Indep: bc,
 doxygen,
 ghostscript,
 graphviz,
 libjs-mathjax,
 texlive-binaries,
 texlive-font-utils,
 texlive-latex-base,
 texlive-latex-extra
Standards-Version: 4.4.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/science-team/trilinos.git
Vcs-Browser: https://salsa.debian.org/science-team/trilinos

Package: trilinos-all-dev
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${mydevpackages}
Suggests: trilinos-doc
Description: object-oriented framework for large-scale problems - development files (ALL)
 The Trilinos Project is an effort to develop algorithms and enabling
 technologies within an object-oriented software framework for the
 solution of large-scale, complex multi-physics engineering and
 scientific problems. A unique design feature of Trilinos is its
 focus on packages.
 .
 This package depends on all Trilinos development packages.

Package: trilinos-dev
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}
Suggests: trilinos-doc
Description: object-oriented framework for large-scale problems - development files
 The Trilinos Project is an effort to develop algorithms and enabling
 technologies within an object-oriented software framework for the
 solution of large-scale, complex multi-physics engineering and
 scientific problems. A unique design feature of Trilinos is its
 focus on packages.
 .
 This package contains the development header and some makefile templates.

Package: libtrilinos-amesos12
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: direct sparse solver package - runtime files
 Amesos is the Direct Sparse Solver Package in Trilinos. The goal of Amesos is
 to make AX=B as easy as it sounds, at least for direct methods. Amesos
 provides clean and consistent interfaces to a number of third-party libraries.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-amesos-dev
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libdevel
# Manually add libtrilinos-trilinosss-dev as dependency until
# <https://github.com/trilinos/Trilinos/issues/2106> is resolved.
Depends: libmumps-dev, libtrilinos-amesos12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}, libtrilinos-trilinosss-dev
Suggests: trilinos-doc
Description: direct sparse solver package - development files
 Amesos is the Direct Sparse Solver Package in Trilinos. The goal of Amesos is
 to make AX=B as easy as it sounds, at least for direct methods. Amesos
 provides clean and consistent interfaces to a number of third-party libraries.
 .
 This package provides headers.

Package: libtrilinos-amesos2-12
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: next generation direct sparse solver package - runtime files
 Amesos2 is a package for solving sparse linear systems using direct solvers.
 It differs from Amesos in that it is templated on the scalar and index types.
 KLU2 is the only native solver.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-amesos2-dev
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libdevel
# Manually add libtrilinos-trilinosss-dev as dependency until
# <https://github.com/trilinos/Trilinos/issues/2106> is resolved.
Depends: libmumps-dev, libtrilinos-amesos2-12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}, libtrilinos-trilinosss-dev
Suggests: trilinos-doc
Description: next generation direct sparse solver package - development files
 Amesos2 is a package for solving sparse linear systems using direct solvers.
 It differs from Amesos in that it is templated on the scalar and index types.
 KLU2 is the only native solver.
 .
 This package provides headers.

Package: libtrilinos-anasazi12
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: large-scale eigenvalue algorithms - runtime files
 Anasazi is an extensible and interoperable framework for large-scale
 eigenvalue algorithms. The motivation for this framework is to provide a
 generic interface to a collection of algorithms for solving large-scale
 eigenvalue problems. Anasazi is interoperable because both the matrix and
 vectors (defining the eigenspace) are considered to be opaque objects -- only
 knowledge of the matrix and vectors via elementary operations is necessary.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-anasazi-dev
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libdevel
Depends: libtrilinos-anasazi12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: large-scale eigenvalue algorithms - development files
 Anasazi is an extensible and interoperable framework for large-scale
 eigenvalue algorithms. The motivation for this framework is to provide a
 generic interface to a collection of algorithms for solving large-scale
 eigenvalue problems. Anasazi is interoperable because both the matrix and
 vectors (defining the eigenspace) are considered to be opaque objects -- only
 knowledge of the matrix and vectors via elementary operations is necessary.
 .
 This package provides headers.

Package: libtrilinos-aztecoo12
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: object-oriented interface to the Aztec solver - runtime files
 AztecOO provides an object-oriented interface to the well-known Aztec solver
 library. Furthermore, it allows flexible construction of matrix and vector
 arguments via Epetra matrix and vector classes. Finally, AztecOO provide
 additional functionality not found in Aztec and any future enhancements to the
 Aztec package will be available only through the AztecOO interfaces.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-aztecoo-dev
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libdevel
Depends: liblapack-dev, libtrilinos-aztecoo12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: object-oriented interface to the Aztec solver - development files
 AztecOO provides an object-oriented interface to the well-known Aztec solver
 library. Furthermore, it allows flexible construction of matrix and vector
 arguments via Epetra matrix and vector classes. Finally, AztecOO provide
 additional functionality not found in Aztec and any future enhancements to the
 Aztec package will be available only through the AztecOO interfaces.
 .
 This package provides headers.

Package: libtrilinos-belos12
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: iterative linear solvers - runtime files
 Belos provides next-generation iterative linear solvers and a powerful linear
 solver developer framework. This framework includes abstract interfaces to
 linear algebra using traits mechanisms, abstract interfaces to
 orthogonalization, abstract interfaces to iteration kernels, powerful solver
 managers, and a basic linear problem class.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-belos-dev
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libdevel
Depends: libtrilinos-belos12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Breaks: libtrilinos-muelu-dev (<< 12.14)
Replaces: libtrilinos-muelu-dev (<< 12.14)
Suggests: trilinos-doc
Description: iterative linear solvers - development files
 Belos provides next-generation iterative linear solvers and a powerful linear
 solver developer framework. This framework includes abstract interfaces to
 linear algebra using traits mechanisms, abstract interfaces to
 orthogonalization, abstract interfaces to iteration kernels, powerful solver
 managers, and a basic linear problem class.
 .
 This package provides headers.

Package: libtrilinos-epetra12
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: basis package for linear algebra - runtime files
 Epetra provides the fundamental construction routines and services function
 that are required for serial and parallel linear algebra libraries. Epetra
 provides the underlying foundation for all Trilinos solvers.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-epetra-dev
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libdevel
Depends: libtrilinos-epetra12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: basis package for linear algebra - development files
 Epetra provides the fundamental construction routines and services function
 that are required for serial and parallel linear algebra libraries. Epetra
 provides the underlying foundation for all Trilinos solvers.
 .
 This package provides headers.

Package: libtrilinos-epetraext12
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: extensions to the Epetra toolkit - runtime files
 EpetraExt provides tools and functions that make it easier to work with
 Epetra.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-epetraext-dev
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libdevel
Depends: libhdf5-openmpi-dev, libtrilinos-epetraext12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: extensions to the Epetra toolkit - development files
 EpetraExt provides tools and functions that make it easier to work with
 Epetra.
 .
 This package provides headers.

Package: libtrilinos-galeri12
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: generation of distributed linear systems - runtime files
 The Trilinos package Galeri contains a suite of utilities and classes to
 generate a variety of (distributed) linear systems. Galeri's functionalities
 are very close to that of the MATLAB's gallery() function.
 Several well-known finite element and finite difference matrices can be
 generated using only a few simple code lines.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-galeri-dev
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libdevel
Depends: libtrilinos-galeri12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: generation of distributed linear systems - development files
 The Trilinos package Galeri contains a suite of utilities and classes to
 generate a variety of (distributed) linear systems. Galeri's functionalities
 are very close to that of the MATLAB's gallery() function.
 Several well-known finite element and finite difference matrices can be
 generated using only a few simple code lines.
 .
 This package provides headers.

Package: libtrilinos-globipack12
Architecture: amd64 arm64 ppc64el s390x ppc64
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 1D globalization capabilities - runtime files

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# dirnames deviate from package names...
LIB_PACKAGES = \
    amesos \
    amesos2 \
    anasazi \
    aztecoo \
    belos \
    epetra \
    epetraext \
    galeri \
    globipack \
    ifpack \
    ifpack2 \
    intrepid \
    intrepid2 \
    isorropia \
    kokkos \
    kokkos-kernels \
    komplex \
    ml \
    moertel \
    muelu \
    nox \
    optipack \
    pamgen \
    phalanx \
    pike \
    piro \
    pliris \
    rol \
    rtop \
    rythmos \
    sacado \
    shards \
    shylu \
    stokhos \
    stratimikos \
    teko \
    teuchos \
    thyra \
    tpetra \
    trilinoscouplings \
    triutils \
    xpetra \
    zoltan \
    zoltan2

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export OMPI_MCA_plm_rsh_agent=/bin/false
export OMPI_MCA_rmaps_base_oversubscribe=1

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_TYPE?=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DOC_TRUE=
DOC_FALSE=
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
   DOC_TRUE=\#
else
   DOC_FALSE=\#
endif

%:
	dh $@ --max-parallel=2

clean:
	rm -f *-stamp
	rm -rf debian/tmp_*
	rm -rf packages/*/doc/html
	rm -rf packages/*/browser/doc/html
	rm -rf packages/rtop/src/*/doc/html
	dh clean

override_dh_auto_configure: configure-stamp


# The below configuration selectively enables packages instead of first
# enabling all via
# ```
# -DTrilinos_ENABLE_ALL_PACKAGES:BOOL=ON \
# -DTrilinos_ENABLE_SECONDARY_TESTED_CODE:BOOL=ON \
# ```
# and then selectively disabling them. This approach is more robust with
# Trilinos updates which sometimes silently enable new packages by default,
# resulting in broken CMake export config files if they are not at the same
# time enabled in Debian.

configure-stamp:
	dh_auto_configure -- \
   -DCMAKE_C_COMPILER=mpicc \
   -DCMAKE_CXX_COMPILER=mpicxx \
   -DCMAKE_Fortran_COMPILER=mpif90 \
   -DBUILD_SHARED_LIBS:BOOL=ON \
   -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
   \
   -DTrilinos_LIBRARY_NAME_PREFIX:STRING="trilinos_" \
   -DTrilinos_INSTALL_INCLUDE_DIR:PATH=include/trilinos/ \
   -DTrilinos_INSTALL_TriBITS:BOOL=OFF \
   -DTrilinos_USE_GNUINSTALLDIRS:BOOL=ON \
   -DTrilinos_ENABLE_DEVELOPMENT_MODE:BOOL=OFF \
   -DTrilinos_ASSERT_MISSING_PACKAGES:BOOL=OFF \
   -DTrilinos_ENABLE_EXPLICIT_INSTANTIATION:BOOL=ON \
   -DTrilinos_ENABLE_EXPORT_MAKEFILES:BOOL=OFF \
   -DTrilinos_ENABLE_EXAMPLES:BOOL=OFF \
   -DTrilinos_ENABLE_TESTS:BOOL=ON \
   \
   -DTrilinos_ENABLE_Amesos:BOOL=ON \
   -DTrilinos_ENABLE_Amesos2:BOOL=ON \
     -DAmesos2_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_Anasazi:BOOL=ON \
     -DAnasazi_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_AztecOO:BOOL=ON \
   -DTrilinos_ENABLE_Belos:BOOL=ON \
     -DBelos_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_Epetra:BOOL=ON \
     -DEpetra_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_EpetraExt:BOOL=ON \
   -DTrilinos_ENABLE_Galeri:BOOL=ON \
   -DTrilinos_ENABLE_GlobiPack:BOOL=ON \
   -DTrilinos_ENABLE_Ifpack:BOOL=ON \
     -DIfpack_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_Ifpack2:BOOL=ON \
   -DTrilinos_ENABLE_Intrepid:BOOL=ON \
   -DTrilinos_ENABLE_Intrepid2:BOOL=ON \
   -DTrilinos_ENABLE_Isorropia:BOOL=ON \
   -DTrilinos_ENABLE_Kokkos:BOOL=ON \
   -DTrilinos_ENABLE_KokkosKernels:BOOL=ON \
   -DTrilinos_ENABLE_Komplex:BOOL=ON \
   -DTrilinos_ENABLE_ML:BOOL=ON \
   -DTrilinos_ENABLE_Moertel:BOOL=ON \
   -DTrilinos_ENABLE_MueLu:BOOL=ON \
     -DMueLu_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_NOX:BOOL=ON \
     -DNOX_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_OptiPack:BOOL=ON \
   -DTrilinos_ENABLE_Pamgen:BOOL=ON \
   -DTrilinos_ENABLE_Phalanx:BOOL=ON \
   -DTrilinos_ENABLE_Pike:BOOL=ON \
   -DTrilinos_ENABLE_Piro:BOOL=ON \
     -DPiro_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_Pliris:BOOL=ON \
   -DTrilinos_ENABLE_ROL:BOOL=ON \
   -DTrilinos_ENABLE_RTOp:BOOL=ON \
   -DTrilinos_ENABLE_Rythmos:BOOL=ON \
   -DTrilinos_ENABLE_Sacado:BOOL=ON \
   -DTrilinos_ENABLE_Shards:BOOL=ON \
   -DTrilinos_ENABLE_ShyLU:BOOL=ON \
   -DTrilinos_ENABLE_Stokhos:BOOL=ON \
   -DTrilinos_ENABLE_Stratimikos:BOOL=ON \
     -DStratimikos_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_Teko:BOOL=ON \
   -DTrilinos_ENABLE_Teuchos:BOOL=ON \
     -DTeuchos_ENABLE_TESTS:BOOL=OFF \
     -DTeuchosComm_ENABLE_TESTS:BOOL=OFF \
     -DTeuchosCore_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_Thyra:BOOL=ON \
   -DTrilinos_ENABLE_Tpetra:BOOL=ON \
   -DTrilinos_ENABLE_TrilinosCouplings:BOOL=ON \
   -DTrilinos_ENABLE_Triutils:BOOL=ON \
   -DTrilinos_ENABLE_Xpetra:BOOL=ON \
     -DXpetra_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_Zoltan:BOOL=ON \
     -DZoltan_ENABLE_TESTS:BOOL=OFF \
   -DTrilinos_ENABLE_Zoltan2:BOOL=ON \
     -DZoltan2_ENABLE_TESTS:BOOL=OFF \
   \
   -DTrilinos_ENABLE_Gtest:BOOL=OFF \
   -DTrilinos_ENABLE_MiniTensor:BOOL=OFF \
   -DTrilinos_ENABLE_MOOCHO:BOOL=OFF \
   -DTrilinos_ENABLE_SEACAS:BOOL=OFF \
   -DTrilinos_ENABLE_STK:BOOL=OFF \
   -DTrilinos_ENABLE_Tempus:BOOL=OFF \
   \
   -DTPL_ENABLE_BinUtils:BOOL=OFF \
   -DTPL_ENABLE_Boost:BOOL=ON \
   -DTPL_ENABLE_HDF5:BOOL=ON \
     -DHDF5_INCLUDE_DIRS:PATH=/usr/include/hdf5/openmpi/ \
     -DHDF5_LIBRARY_DIRS:PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/openmpi/ \
   -DTPL_ENABLE_Matio:BOOL=OFF \
   -DTPL_ENABLE_MATLAB:BOOL=OFF \
   -DTPL_ENABLE_MPI:BOOL=ON \
   -DTPL_ENABLE_MUMPS:BOOL=ON \
   -DTPL_ENABLE_Netcdf:BOOL=OFF \
   -DTPL_ENABLE_ParMETIS:BOOL=OFF \
   -DTPL_ENABLE_Scotch:BOOL=ON \
     -DScotch_INCLUDE_DIRS:PATH=/usr/include/scotch/ \
   -DTPL_ENABLE_SuperLU:BOOL=OFF \
   -DTPL_ENABLE_TBB:BOOL=ON \
   -DTPL_ENABLE_X11:BOOL=OFF \
   -DTPL_ENABLE_Zlib:BOOL=ON
	touch $@

BUILDDIR=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)

doc_build-stamp: $(DOC_TRUE)$(LIB_PACKAGES:%=%_doc-stamp)
	touch $@

# ignoring return code. some parts just fail!
$(LIB_PACKAGES:%=%_doc-stamp): %_doc-stamp:
	-cd packages/$*/doc && ./build_docs
	touch $@

override_dh_auto_install-indep: auto_install-indep-stamp
override_dh_auto_install-arch: auto_install-arch-stamp

auto_install-indep-stamp: doc_build-stamp
	mkdir -p $(CURDIR)/debian/tmp_trilinos-doc/usr/share/doc/trilinos;
	for i in $(LIB_PACKAGES); do \
	  echo "cp -r packages/$$i/doc/html/ $(CURDIR)/debian/tmp_trilinos-doc/usr/share/doc/trilinos/$$i"; \
	  cp -r packages/$$i/doc/html/ $(CURDIR)/debian/tmp_trilinos-doc/usr/share/doc/trilinos/$$i || :; \
	done
	touch $@

auto_install-arch-stamp:
	for i in $(LIB_PACKAGES); do \
     if [ -d $(BUILDDIR)/packages/$$i ]; then \
	    $(MAKE) -C $(BUILDDIR)/packages/$$i install DESTDIR=$(CURDIR)/debian/tmp_$$i || exit 1; \
	  else \
	    echo "WARNING: $@, no $$i has been built" >&2; \
       sleep 3; \
	  fi; \
	done
	$(MAKE) -C $(BUILDDIR)/packages/shylu/shylu_dd install DESTDIR=$(CURDIR)/debian/tmp_shylu || exit 1
	$(MAKE) -C $(BUILDDIR)/packages/shylu/shylu_node install DESTDIR=$(CURDIR)/debian/tmp_shylu || exit 1
	$(MAKE) -C $(BUILDDIR)/packages/common/auxiliarySoftware/SuiteSparse/ install DESTDIR=$(CURDIR)/debian/tmp_trilinosss || exit 1
	$(MAKE) -C $(BUILDDIR) install/local DESTDIR=$(CURDIR)/debian/tmp_trilinos-dev
	touch $@

V = $(shell grep -Po 'Trilinos_MAJOR_VERSION \K[\d\.]*' Version.cmake)
MV = $(shell grep -Po 'Trilinos_MAJOR_MINOR_VERSION \K[\d\.]*' Version.cmake)

SOVERSION=$(V)

debian/Trilinos_version.h: debian/Trilinos_version.h.in auto_install-arch-stamp
	test -f $(TV)
	sed -e 's/%V/$(V)/' \
	    -e 's/%MV/$(MV)/' $< > $@

LO_DIR = /usr/share/lintian/overrides

override_dh_install-indep: install-indep-stamp
install-indep-stamp: auto_install-indep-stamp
	@for i in $(LIB_PACKAGES); do \
	  echo "dh_install --sourcedir=debian/tmp_trilinos-doc -ptrilinos-doc --autodest usr/share/ || exit 1;" \
	  dh_install --sourcedir=debian/tmp_trilinos-doc -ptrilinos-doc --autodest usr/share/ || exit 1; \
	done
	dh_install --sourcedir=debian/tmp_trilinos-doc -ptrilinos-doc --autodest usr/share/doc
